
#include "allegro.h"
#include "gfx.h"

#ifdef DEBUGMODE
#include "fortify.h"
#endif


static BITMAP *oldscreen = NULL;
BITMAP *BackBuffer = NULL;


int GFX_Init(int w, int h, int c) {

	if (oldscreen)
		destroy_bitmap(oldscreen);
	if (BackBuffer)
		destroy_bitmap(BackBuffer);	

	set_color_depth(c);
	#ifdef DEBUGMODE
	//if (set_gfx_mode(GFX_GDI, w, h, 0, 0)) {
	//if (set_gfx_mode(GFX_DIRECTX_WIN, w, h, 0, 0)) {	
	if (set_gfx_mode(GFX_AUTODETECT, w, h, 0, 0)) {	
	#else
	if (set_gfx_mode(GFX_AUTODETECT, w, h, 0, 0)) {	
	#endif
		allegro_message("Can't set graphics mode!\n");
		return -1;
	}

	oldscreen = create_video_bitmap(w, h);


	/*BackBuffer = GFX_CreateAccelBitmap(DISPLAY_W, DISPLAY_H);

	if (!BackBuffer) {
		GFX_Shutdown();
		allegro_message("Can't create backbuffer!");
		return -1;
	}
	clear(BackBuffer);
	*/

	return 0;
}



int GFX_Shutdown() {

	if (oldscreen)
		destroy_bitmap(oldscreen);

	/*
	if (BackBuffer)
		destroy_bitmap(BackBuffer);
*/
	set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);

	oldscreen = NULL;
	BackBuffer = NULL;

	return 0;
}	


BITMAP *GFX_CreateAccelBitmap(int w, int h) {

	BITMAP *ret = NULL;
/*
	if (gfx_capabilities & GFX_HW_VRAM_BLIT)
		ret = create_video_bitmap(w, h);
*/
	if (!ret && (gfx_capabilities & GFX_HW_SYS_TO_VRAM_BLIT))
		ret = create_system_bitmap(w, h);

	if (!ret)
		ret = create_bitmap(w, h);

	return ret;
}

BITMAP *GFX_CreateAccelMaskedBitmap(int w, int h) {

	BITMAP *ret = NULL;	
/*
	if (gfx_capabilities & GFX_HW_VRAM_BLIT_MASKED)
		ret = create_video_bitmap(w, h);

	if (!ret && (gfx_capabilities & GFX_HW_SYS_TO_VRAM_BLIT_MASKED))
		ret = create_system_bitmap(w, h);
*/
	if (!ret)
		ret = create_bitmap(w, h);

	return ret;
}

void GFX_HQ_RotateSprite(BITMAP *dest, BITMAP *src, int x, int y, fixed angle) {

	BITMAP *temp1 = create_bitmap(src->w * 2,  src->h * 2);

	stretch_blit(src, temp1, 0, 0, src->w, src->h, 0, 0, temp1->w, temp1->h);
	rotate_scaled_sprite(dest, temp1, x, y, angle, ftofix(0.5));

	destroy_bitmap(temp1);

	return;
}


