
#define INVINCIBILITY_TIME 75

#define PLAYER_ALIVE 1
#define PLAYER_INVINCIBILITY 2

typedef struct PLAYER {

	struct PARTICLE *Particle;

	struct SHIP_WEAPON **Weapon;
	int NumWeapons;
	int SelectedWeapon;

	int Invincible;
	int hp, maxhp;
	int Score;

	int old_score, old_hp, old_ammo, old_prop;

	int Properties;

	struct INPUT *Input;

} PLAYER;


extern PLAYER *create_player();
extern void destroy_player(PLAYER *);

extern void set_player_bitmap(PLAYER *p, BITMAP *bmp);
extern void set_player_coord(PLAYER *p, float x, float y);
extern void get_player_velocity(PLAYER *p, float *vx, float *vy);
extern int get_player_property(PLAYER *p, int prop);
extern void get_player_velocity(PLAYER *p, float *vx, float *vy);
extern int get_player_property(PLAYER *p, int prop);
extern void set_player_invincibility(PLAYER *p, int val);
extern float get_player_angle(PLAYER *p);
extern void get_player_coord(PLAYER *p, float *x, float *y);
extern void set_player_hp(PLAYER *p, int hp, int maxhp);
extern int get_player_hp(PLAYER *p);
extern int get_player_maxhp(PLAYER *p);
extern PARTICLE *get_player_particle(PLAYER *p);

extern void add_player_score(PLAYER *p, int val);
extern int get_player_score(PLAYER *p);
extern void set_player_property(PLAYER *p, int prop);
extern void unset_player_property(PLAYER *p, int prop);

extern void set_player_next_shot_delay(PLAYER *p, int val);
extern int get_player_next_shot_delay(PLAYER *p);
extern int get_player_ammo(PLAYER *p);
extern int get_player_ammo_percent(PLAYER *p);

extern void add_player_weapon(PLAYER *p, struct WEAPON *w);
extern void remove_player_weapon(PLAYER *p, struct WEAPON *w);
extern void remove_all_player_weapons(PLAYER *p);
extern void select_player_weapon(PLAYER *p, struct WEAPON *w);
extern int player_has_weapon(PLAYER *p, struct WEAPON *w);
extern struct WEAPON *get_player_weapon(PLAYER *p);

extern int player_fire(PLAYER *p);


extern void clear_players();
extern int install_player();


extern struct PARTICLE* get_player_particle(PLAYER *p);


extern int player_get_input_up(PLAYER *p);
extern int player_get_input_down(PLAYER *p);
extern int player_get_input_right(PLAYER *p);
extern int player_get_input_left(PLAYER *p);
extern int player_get_input_fire(PLAYER *p);

extern void load_player_input(PLAYER *p, int n);

